package com.zipcodewilmington.arrayutility;

import javax.xml.bind.Element;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<T> {

    private T[] array;

    public ArrayUtility(T[] array) {
        this.array = array;
    }

//    ArrayList<Integer> integerArrayList = new ArrayUtility<>();

    public Integer countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {
        int count = 0;
        mergeArrays(arrayToMerge);
        for (T value : array) { if (value.equals(valueToEvaluate)) { count ++; } }
        return count;
    }

    public Integer getNumberOfOccurrences(T valueToEvaluate) {
        int count = 0;
        for(T t : array) {
            if(t.equals(valueToEvaluate)) count ++; }
        return count;
    }

    public T[] removeValue(T valueToRemove) {
        int occurence = countOccurence(valueToRemove);
        T[] tempArray = (T[]) Array.newInstance(this.array.getClass().getComponentType(), array.length - occurence);
        int i = 0;
        for (T value : array) { if (value != valueToRemove){ tempArray[i] = value; i ++; } }
        array = tempArray;
        return array;
    }

    private T[] getArray() { return this.array; }

    public T[] mergeArrays(T[] arrayToMerge) {
        T[] tempArray = (T[]) new Object[array.length + arrayToMerge.length];
        for(int i = 0; i < tempArray.length; i++) {
            if (i < array.length) { tempArray[i] = array[i]; }
            else { tempArray[i] = arrayToMerge[i - array.length]; }
        }
        array = tempArray;
        return array;
    }

    public T getMostCommonFromMerge(T[] arrayToMerge) {
        mergeArrays(arrayToMerge);
        T mostCommon = null;
        int maxOccurence = 0;
        for (T value : array) { int occurence = countOccurence(value); if (occurence > maxOccurence)
            mostCommon = value;} return mostCommon;
    }

    private int countOccurence(T t) {
        int count = 0;
        for (T tObject : array) { if (tObject == t) { count += 1; } } return count;
    }
}